/* A seconda del tipo di blocco, restituisce il suo colore */
Uint32 blockColor(unsigned char tipo)
{
  Uint32 colore;
  switch (tipo)
  {
    case blocktype0: case blocktype1: colore = 0x000000FF; break;
    case blocktype2: colore = 0x008200FF; break;
    case blocktype3: colore = 0xB40000FF; break;
    case blocktype4: colore = 0x0000B4FF; break;
    case blocktype5: colore = 0xFDD017FF; break;
    case blocktype6: colore = 0x800080FF; break;
    case blocktype7: colore = 0xFF00FFFF; break;
    case blocktype8: colore = 0xFFA500FF; break;
    case blocktype9: colore = 0xFFFF00FF; break;
    case blocktype10: colore = 0xFFFFFFFF; break;
    case blocktype11: colore = 0x000000FF; break; // Per Debug sostituire con 0xFF0000B4
    case blocktype12: colore = 0x404040FF; break;
    case blocktype13: colore = 0x606060FF; break;
    case blocktype14: colore = 0x505050FF; break;
    case blocktype15: colore = 0x404040FF; break;
    case blocktype16: colore = 0x00D2D2FF; break;
    case blocktype17: colore = 0x716A0FFF; break;
    case blocktype18: colore = 0xFFAA00FF; break;
    case blocktype19: colore = 0x65B0D2FF; break;
    default: colore = 0x400000CC; clog << "[W] BadBlock!" << flush; break;
  }
  return colore;
}

class brick
{
  private:
    /* A seconda del tipo di blocco, restituisce il numero di texture
     * in caso di blocco inesistente restituisce -1 */
    short blockTexture(unsigned char tipo)
    {
      short i;
      switch (tipo)
      {
        case blocktype0: case blocktype1: i = 0; break;
        case blocktype2: i = 1; break;
        case blocktype3: i = 2; break;
        case blocktype4: i = 3; break;
        case blocktype5: i = 4; break;
        case blocktype13: i = 5; break;
        case blocktype14: i = 6; break;
        case blocktype15: i = 7; break;
        case blocktype12: i = 8; break;
        default: i = -1; break;
      }
      return i;
    }
  public:
    unsigned char tipo;
    bool strong;
    bool init(unsigned char t)
    {
      tipo = t;
      switch (tipo)
      {
        case blocktype10: case blocktype11: case blocktype12: strong = true;
        default: strong = false;
      }
    }
    bool grafica(short x, short y) /* beh, sì, il blocco è un oggetto ma non sa dov'è */
    {
      Uint32 colore;
      short i = 0;
      if (! opzione.lq && (i = blockTexture(tipo)) > -1)
      {
        SDL_Rect spostamento;
        spostamento.x = x * largBlock;
        spostamento.y = y * altBlock;
        SDL_BlitSurface(texture[i], NULL, schermo, &spostamento);
      }
      else
      {
        /* per maggiori informazioni vedere leggimi.txt nelle Note per i Programmatori */
        colore = blockColor(tipo);
        boxColor(schermo, x * largBlock, y * altBlock, x * largBlock + largBlock - 2, y * altBlock + altBlock - 2, colore);
      }
      return true;
    }
    bool colpito()
    {
      unsigned short snd = 0;
      strong = false;
      switch (tipo)
      {
        case blocktype2: player.punti = player.punti + 10; tipo--; break;
        case blocktype3: case blocktype4: player.punti = player.punti + 5 ; tipo--; break;
        case blocktype5: bonus_gold(); tipo = 9; break;
        case blocktype10: bonus_extralife(); tipo = 9; strong = true; break;
        case blocktype11: bonus_theboss(); tipo = 13; strong = true; break;
        case blocktype12: snd = 2; player.punti++; break;
        case blocktype13: tipo = 9; break;
        case blocktype14: case blocktype15: player.punti++; snd = 2; tipo--; break;
        default: player.punti++; tipo = 8; break;
      }
      suona(snd);
    }
  };

