/* In effetto[] sono contenuti i puntatori a tutti gli effetti sonori;
 * questa funzione suona quello richiesto (se il sonoro è abilitato nelle opzioni) */
void suona(unsigned short n)
{
  if (opzione.sonoro)
  {
    Mix_PlayChannel(-1, effetto[n], 0);
  }
}

/* Restituisce true se il livello è completato (non ci sono blocchi sullo schermo) */
bool completato()
{
  for (short x = 0; x < width; x++)
    for (short y = 0; y < height; y++)
      { if (block[x][y].tipo >  9 && block[x][y].tipo < 128) return false; }
  return true;
}

#include "bonus.cpp"

class ball {
  private:
    bool attivo, proiettile;
    double xv, yv;
    double speed; /* modulo della velocità */
    angolo direzione;
    Uint32 colore;
    char urto(unsigned int xa, unsigned int ya)
    {
      xa = xa / largBlock; ya = ya / altBlock;
      if (direzione.sin == 0 || direzione.cos == 0) return 'l'; /* Non considera i casi limite */
      /* Se qui c'è un pezzo... - vedere anche leggimi.txt */
      if (block[xa][ya].tipo > 9)
      {
        block[xa][ya].colpito(); /* Blocco colpito! */
        /* Fa rimbalzare la pallina... */
        if (! trapassa || block[xa][ya].strong)
        {
          int xva = xv / largBlock, yva = yv / altBlock;
          if (xva == xa) direzione.sin = -direzione.sin;
            else if (yva == ya) direzione.cos = -direzione.cos;
              else
              {
                /* Caso eccezionale, il pezzo viene colpito preciso nell'angolo! */
                direzione.cos = -direzione.cos; direzione.sin = -direzione.sin;
                cout << "[I] Extraordinary case: you hit the block in its corner.\n";
              }
          /* ...e la rimette dov'era prima, onde evitare spiacevoli loop */
          x = xv; y = yv;
        }
        return 'b';
      }
      if (completato()) return 'c'; /* Livello completato */
    return 'o'; /* Ok */
    }
    bool scia()
    {
      for (short v = 0; v < 25; v++)
      { int aero = aCaso() * opzione.difficolta * 10;
        pixelRGBA(schermo, x +  aero * -direzione.cos + (aCaso() * 5 - 3), y + aero * direzione.sin + (aCaso() * 5 - 3), 0xF0 + (aCaso() * 30 - 16), 180 + (aCaso() * 40 - 20), 0, 0xFF);
      }
    }
  public:
    double x, y;
    bool trapassa;
    bool init(bool is_active = false, bool is_missle = false, bool force_init = false)
    {
      if (is_active)
      {
        if (force_init && ! is_active) { attivo = false; return true; }
        if (is_missle)
        {
          if (! attivo || force_init)
          {
            x = player.x; y = 450;
            direzione.cos = cos(M_PI / 2); direzione.sin = sin(M_PI / 2);
            speed = 0.7;
            trapassa = false;
            attivo = true;
            proiettile = true;
            return true;
          }
        }
        else
        {
          if (! attivo || force_init)
          {
            x = 320; y = 450;
            /* Direzione casuale della pallina all'avvio, come consigliato da lucam */
            double tmpAngle = ((double)(rand()) / (double)(RAND_MAX)) * M_PI;
            if (tmpAngle < M_PI / 4) tmpAngle = M_PI / 4;
            else if (tmpAngle > M_PI * 3 / 4) tmpAngle = M_PI * 3 / 4;
            direzione.cos = cos(tmpAngle);
            direzione.sin = sin(tmpAngle);
            speed = 0.1 * player.difficolta;
            trapassa = false;
            attivo = true;
            proiettile = false;
            gameinfo.activeBalls++;
            return true;
          }
        }
      }
      else { attivo = false; return true; }
      return false;
    }
    char muovi() {
      if (attivo)
      {
        xv = x; yv = y;
        x = x + speed * direzione.cos;
        y = y - speed * direzione.sin;
      }
      else return 'u';
      switch (urto(x, y))
      {
        case 'c': attivo = false; return 'c'; break; /* Livello completato*/
        case 'b': if (proiettile) attivo = false; return 'b'; break; /* Blocco colpito! */
        case 'l': /*if (! proiettile) */cout << "[I] Extraordinary case: sin (xor cosin) of the ball was 0\n"; break;
      }
      /* Rimbalzo su bordo o paddle */
      if (! proiettile)
      {
        if (x >= 639 || x <= 0) direzione.cos = -direzione.cos;
        if (y <= 0) direzione.sin = -direzione.sin;
        if (y >= 460)
        {
          // cout << "V: " << xv << " " << yv << " N: " << x << " " << y << " L: " << player.x << " " << player.lung << endl;
          if (x > (player.x - player.lung) && x < (player.x + player.lung))
          {
            /* Calcolo del nuovo coseno dell'angolo in funzione del punto del paddle
               col quale il giocatore urta la palla */
            double corner = (x - (player.x - player.lung)) * M_PI / (player.lung * 2);
            if (corner < M_PI / 12) corner = M_PI / 12;
              else if (corner > M_PI * 11 / 12) corner = M_PI * 11 / 12;
            direzione.cos = -cos(corner);
            if (direzione.sin < 0) player.punti--;
            direzione.sin = sin(corner);
            return 'h'; /* Paddle colpito */
          }
          else if (y > 470) { attivo = false; return 'l'; }/* Pallina persa */
        }
      }
      else
      {
        if (y < 0) attivo = false;
      }
      return 'o'; /* Ok, nothing special */
    }
    bool grafica()
    {
      if (attivo)
      {
        if (proiettile)
        {
          filledCircleColor(schermo, x, y, 2, 0xC8C8C8FF);
        }
        else
        {
          if (trapassa) colore = 0xFF0000FF;
            else colore = 0xC8C8C8FF;
          filledCircleColor(schermo, x, y, 5, colore);
          if (trapassa) scia();
        }
      }
    }
    char controllo()
    {
      if (! proiettile)
      {
        if (speed < 0.1) { speed = 0.1; return 's'; }
        if (speed > 1) { speed = 1; return 's'; }
      }
      return 'n';
    }
    /* cambia la velocità */
    void accel(double acceleration) { if (! proiettile) speed = speed + acceleration; }
};

int n_balls = 5; /* sia palline vere e proprie che missili */
ball* palla = new ball[n_balls];

/* Alloca altra memoria per palline/missili */
bool moreballs()
{
  cout << "[I] Allocating memory for new balls... ";
  ball* tmp = new ball[n_balls + 1];
  if (tmp == NULL) { clog << endl << "[W] Not enough memory for new balls!" << endl; return false; }
  for (short n = 0; n < n_balls; n++)
    { tmp[n] = palla[n]; }
  delete [] palla;
  n_balls++;
  palla = new ball[n_balls];
  if (palla == NULL) { clog << endl << "[W] Not enough memory for new balls!" << endl; return false; }
  for (short n = 0; n < n_balls; n++) { palla[n] = tmp[n]; }
  delete [] tmp;
  cout << "[" << n_balls << "] done" << endl;
  return true;
}

bool cloneballs()
{
  for (short n = 0; n < n_balls; n++)
    { if (palla[n].init(true, false)) return true; }
  return false;
}

class cadente {
  private:
    double x, y0, y;
    Uint32 t0;
    bool attivo;
    unsigned char tipo;
    SDL_Rect spostamento;
    bool urto()
    {
      if (y >= 460)
      {
        if (x > player.x - player.lung && x < player.x + player.lung)
        {
          unsigned short snd = 3;
          switch(tipo)
          {
            case blocktype0: case blocktype1: case blocktype2: case blocktype3:
            case blocktype13: case blocktype14: case blocktype15:
              clog << "[W] This block can not be used as a falling block!\n"; break;
            case blocktype4: bonus_triplo(); break;
            case blocktype5: bonus_gold(); break;
            case blocktype6: for (short n = 0; n < n_balls; n++) palla[n].accel(-0.1); break;
            case blocktype7: for (short n = 0; n < n_balls; n++) palla[n].accel(+0.1); snd = 4; break;
            case blocktype8: bonus_paddle_enlarge(); break;
            case blocktype9: bonus_paddle_decrease(); snd = 4; break;
            case blocktype10: bonus_extralife(); break;
            case blocktype11: bonus_theboss(); break;
            case blocktype12: bonus_indistruttibile(); snd = 4; break;
            case blocktype16: for (short n = 0; n < n_balls; n++) { palla[n].trapassa = true; } break;
            case blocktype17: bonus_sparaspara(); break;
            case blocktype18:
              if (! cloneballs())
              {
                if (moreballs())
                  { palla[n_balls - 1].init(true, false, true); }
                else
                  { clog << "[W] No more balls initialized!" << endl;}
              }
              break;
            case blocktype19: gameinfo.bonus_percent = 90; break;
            default: clog << "[W] Unknown falling bonus block!\n"; msg("Bonus non riconosciuto", 1000); break;
          }
          suona(snd);
          attivo = false;
          return true;
        }
        if (y > 479) attivo = false;
      }
      return true;
    }
  public:
    /* 'n' palla da cui prendere le coordinate di partenza,
     * 'init_type' tipo di blocco, scelto a caso se == 0*/
    bool init(short n, short init_type = 0)
    {
      if (! attivo && (time(NULL) - lasttime.bonus) >= (1 * gameinfo.activeBalls))
      {
        if (! init_type)
        {
          tipo = blockRandomTypes[(int)(aCaso() * (N_RAND_BLOCKS - 1))];
          x = palla[n].x; y0 = palla[n].y; y = 0;
        }
        else
        {
          tipo = init_type;
          x = 320; y0 = 0; y = 0;
        }
        t0 = SDL_GetTicks();
        attivo = true;
        suona(5);
        lasttime.bonus = time(NULL);
        return true;
      }
      else return false;
    }
    bool muovi()
    {
      if (attivo)
      {
        double t = (double)(SDL_GetTicks() - t0) / (double)(1000);
        y = y0 + -40 * t + (15 * (player.difficolta)) * pow(t, 2); /* Moto accelerato */
        urto();
      }
      return true;
    }
    bool grafica()
    {
      if (attivo)
      {
        unsigned short i = 0;
        switch(tipo)
        {
          case 0: break;
          case blocktype4: i = 4; break;
          case blocktype5: i = 5; break;
          case blocktype7: i = 1; break;
          case blocktype6: i = 2; break;
          case blocktype16: i = 3; break;
          case blocktype12: i = 6; break;
          case blocktype8: i = 7; break;
          case blocktype9: i = 8; break;
          case blocktype10: i = 9; break;
          case blocktype17: i = 10; break;
          case blocktype18: i = 11; break;
          case blocktype11: i = 12; break;
          case blocktype19: i = 13; break;
          default: filledCircleColor(schermo, x, y, 20, blockColor(tipo) - 80); break;
        }
        if (i)
        {
          spostamento.x = x - (icona[i]->w >> 1); spostamento.y = y - (icona[i]->h >> 1); /*divisione per 2*/
          SDL_BlitSurface(icona[i], NULL, schermo, &spostamento);
        }
      }
      return true;
    }
};

#define n_bonus 6
cadente bonus[n_bonus]; /* Possono cadere fino a 6 bonus contemporaneamente */

