/* Ritorna 'true' quando il tasto richiesto è stato premuto e rilasciato
 * oppure è stato premuto per più di 150ms */
bool premuto(int tipo)
{
  if (tasto[tipo])
  {
    long presstime = SDL_GetTicks();
    while(tasto[tipo])
    { SDL_PumpEvents(); SDL_Delay(20); if (SDL_GetTicks() - presstime > 150) break; }
    return true;
  }
  return false;
}

/* Mostra una finestrina a schermo con una comunicazione
 * e attende la pressione di SPAZIO per ritornare
 * con '\a' non mostra niente e attende SPAZIO
 */
void msg(const char* messaggio, unsigned short wait)
{
  mouse(true);
  if (messaggio[0] != '\a')
  {
    //~
    //~ int lung = strlen(messaggio);
    //~ int x = 320 - (lung * FONTW / 2);
    //~ boxColor(schermo, x - 10, 228, x + (FONTW * lung) + 10, 267, 0x006400FF);
    //~ stringColor(schermo, x, 240, messaggio, 0xFFFFFFFF);
    font(0, 0, messaggio, 0xFFFFFF, 0x006400, true);
    //~ rectangleColor(schermo, x - 9, 230, x + (FONTW * lung) + 9, 265, 0xAA0000FF);
    SDL_Flip(schermo);
  }
  while (SDL_PollEvent(&evento)) {;} /* Svuota la coda degli eventi */

  Uint32 inizio = SDL_GetTicks();
  while (true)
  {
    SDL_PollEvent(&evento);
    if (evento.type == SDL_KEYDOWN) if (evento.key.keysym.sym == SDLK_SPACE) break;
    if (evento.type == SDL_MOUSEBUTTONDOWN) break;
    if (wait) if ((SDL_GetTicks() - inizio) >= wait) break;
    SDL_Delay(20);
  }
  mouse(false);
}

int cursorX = 5, cursorY = 5;

/* Scrive con effetto Commodore64 (a ritardo) */
static void scrivi(const char * stringa)
{
  char flag = 0;
  for (short c = 0; c < strlen(stringa); c++)
  {
    switch (stringa[c])
    {
      case '\n': cursorY = cursorY + 16; cursorX = 5; break;
      case '\a': cursorX = 5; cursorY = 5; break;
      default: characterColor(schermo, cursorX, cursorY, stringa[c], 0x00EE00FF);
    }
    cursorX = cursorX + FONTW;
    if (! flag) { SDL_Flip(schermo); SDL_Delay(9); flag = 5; }
    flag--;
  }
  SDL_Flip(schermo);
}

void info()
{
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  scrivi("\n");
  scrivi("\aP Pong\n"); // by Giovan Battista Rolandi\n");
  scrivi("\n");
  scrivi("Istruzioni:\n");
  scrivi("Lo scopo del gioco consiste nel distruggere tutti i mattoni nella\n");
  scrivi("area di gioco con una palla. La palla rimbalza automaticamente\n");
  scrivi("sui mattoni, sui bordi e sulla racchetta, che viene mossa dal\n");
  scrivi("giocatore.\n");
  scrivi("Se la palla non viene presa dalla racchetta, il giocatore viene\n");
  scrivi("penalizzato. Se la palla viene persa piu' volte di seguito,\n");
  scrivi("allora il gioco termina.\n");
  scrivi("Ogni mattone, a seconda del colore con cui viene mostrato, da' al\n");
  scrivi("giocatore un diverso punteggio. Alcuni mattoni devono essere\n");
  scrivi("colpiti piu' volte, prima che vengano definitivamente distrutti.\n");
  scrivi("Colpendo i mattoni possono essere sorteggiati dei bonus o malus,\n");
  scrivi("che permettono di modificare la velocita' della palla, oppure la\n");
  scrivi("dimensione della racchetta, e cosi' via...\n");
  scrivi("Una volta colpiti e distrutti tutti i mattoni sullo schermo,\n");
  scrivi("e' possibile passare al livello successivo; non e' indispensabile\n");
  scrivi("colpire i mattoni speciali.\n");
  scrivi("\n");
  scrivi("Comandi durante il gioco:\n");
  scrivi("Frecce direzionali per muovere la racchetta a sinistra e destra\n");
  scrivi("P     Pausa\n");
  scrivi("A     Salta al livello successivo\n");
  scrivi("S     Salva la partita\n");
  scrivi("ESC   Salva la partita ed esce\n");
  scrivi("F     Schermo intero");
  scrivi("\n");
  msg("\a");
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  scrivi("\aLicenza: Creative Commons BY - NC - SA\n");
  scrivi("http://creativecommons.org/licenses/by-nc-sa/3.0/it/legalcode\n");
  scrivi("\n");
  scrivi("Questo programma viene distribuito con la speranza che sia utile e\n");
  scrivi("divertente, ma senza alcuna garanzia.\n");
  scrivi("Gli autori non sono responsabili di nessun danno a cose o persone\n");
  scrivi("attribuibili ad un qualsiasi utilizzo di questo gioco.\n");
  scrivi("Ogni parte di questo programma puo' essere riutilizzata e modificata\n");
  scrivi("per qualsiasi scopo (entro i limiti della legalita'), MA\n");
  scrivi("e' severamente proibito l'utilizzo commerciale.\n");
  scrivi("Questo programma puo' essere modificato e/o ridistribuito,\n");
  scrivi("a condizione che ne vengano citati esplicitamente gli autori.\n");
  scrivi("Non e' consentito rilasciare versioni di questo programma sotto una\n");
  scrivi("licenza diversa da questa.\n");
  scrivi("\n");
  scrivi("Informazioni:\n");
  scrivi("Nome del gioco:   P Pong\n");
  scrivi("Versione:         "); scrivi(versione); scrivi("\n");
  scrivi("Linguaggio:       C++\n");
  scrivi("Piattaforma:      Linux - Windows - Mac OS X\n");
  scrivi("Data:             Luglio 2012 - Agosto 2013\n");
  scrivi("Per ulteriori informazioni, avviare da riga di comando con opzione -h\n");
  scrivi("\n");
  scrivi("Autori:\n");
  scrivi("* codice:   Giovan Battista Rolandi - http://www.glgprograms.tk/\n");
  scrivi("* immagini: Ilaria Angelotti        - zehira@hotmail.it\n");
  scrivi("\n");
  scrivi("PS: Questo effetto Commodore e' molto accattivante :D");
  SDL_Delay(1000);
  msg("\a");
}

void infocmd()
{
  cout << endl;
  cout << "P Pong" << endl;
  cout << "Opzioni accettate da riga di comando:" << endl;
  cout << " -l #  Avvia il gioco dal livello # specificato" << endl;
  cout << " -d #  Imposta la difficolta' di gioco # (1-6)" << endl;
  cout << " -m    Avvia senza il sonoro" << endl;
  cout << " -f    Avvia il gioco a schermo intero (passare come ultimo parametro!)" << endl;
  cout << "         Non funziona su tutti i monitor. Provare anche con -c" << endl;
  cout << " -c    Utilizza uno schermo compatibile in 4:3 (pan and scan)" << endl;
  cout << " -#    Imposta la profondità di colore # (1, 2, 3, 4 per 8, 16, 24, 32 bpp)" << endl;
  cout << "         Per ottenere le massime prestazioni provare vari schermi/bpp" << endl;
  cout << " -w    Ottiene direttamente i comandi senza interfacciarsi col WM" << endl;
  cout << " -q    Avvia il gioco in bassa qualità, risparmiando memoria" << endl;
  cout << " -v    Visualizza il numero di versione del programma ed esce" << endl;
  cout << " -h    Mostra questo messaggio d'aiuto" << endl;
  cout << endl;
  cout << "Per il debug, utilizzare i cheat codes premendo 'c' durante il gioco" << endl;
  cout << endl;
}

void infolog()
{
  cout << "P Pong " << endl;
  cout << "Here in command line you can read the program's log, so you can check" << endl;
  cout << "for errors and report them." << endl;
  cout << "[I] is a piece of information which program normally outputs" << endl;
  cout << "[W] indicates a Warning, so something went wrong but the program was able to fix" << endl;
  cout << "[E] indicates a Fatal Error, so the program may crash or be unstable." << endl;
  cout << "When an [E] error occurs, you may consider to restart the program." << endl;
  cout << endl;
}

/*
 * Scrive qualcosa sullo schermo col carattere preimpostato con TTF_Font oppure
 * con i font predefiniti, nel caso in cui non si riesca a carica il ttf
 * Uint32 x   spostamento sull'asse delle ascisse X; se 0 il testo viene centrato
 * Uint32 y   spostamento sull'asse delle ordinate Y; se 0 il testo viene centrato
 * const char * testo   il testo da stampare
 * Uint32 fgColor       colore del testo nel formato 0xRRVVBB
 * Uint32 bgColor       colore dello sfondo (opzionale) 0xRRVVBB
*/
static bool font(Uint32 x, Uint32 y, const char * testo, Uint32 fgColor, Uint32 bgColor, bool box)
{
  if (carattere == NULL)
  {
    fgColor = fgColor * 0x100 + 0xFF; bgColor = bgColor * 0x100 + 0xFF;
    Uint32 w = (strlen(testo) * FONTW);
    if (! x) x = 320 - (w >> 1);
    if (! y) y = 240 - (FONTH  >> 1);
    if (box)
    {
      roundedBoxColor(schermo, x - 9, y - 9, x + w + 9, y + FONTH + 9, 3, bgColor);
    }
    stringColor(schermo, x, y, testo, fgColor);
    return true;
  }
  else
  {
    SDL_Color fg, bg;
    fg.b = fgColor % 0x100;             bg.b = bgColor % 0x100;
    fg.g = (fgColor >> 8) % 0x100;   bg.g = (bgColor >> 8) % 0x100; /* Nota: >> 8 vuol dire dividi per 0x100  */
    fg.r = (fgColor >> 16) % 0x100; bg.r = (bgColor >> 16) % 0x100; /* e ovviamente >> 16 vuol dire dividi per 0x10000*/
    if (strlen(testo))
    {
      SDL_Surface *tmp = TTF_RenderText_Shaded(carattere, testo, fg, bg);
      if (tmp == NULL) { cerr << "[E] Unable to TTF_RenderText()! Message: '" << testo << "'\n"; return false; }
      else
      {
        SDL_Rect spostamento;
        if (! x) x = 320 - ((tmp->w) >> 1);
        if (! y) y = 240 - ((tmp->h) >> 1);
        spostamento.x = x; spostamento.y = y;
        if (box) roundedBoxColor(schermo, spostamento.x - 9, spostamento.y - 9, spostamento.x + tmp->w + 9, spostamento.y + tmp->h + 9, 3, (bgColor << 8) + 0xFF);
        SDL_BlitSurface(tmp, NULL, schermo, &spostamento);
        SDL_FreeSurface(tmp);
        return true;
      }
    }
  }
}
