/* Legge livello da file, a partire dall'offset passato come parametro */
bool readlvl(unsigned long b)
{
  cout << "[I] Reading level from file... ";
  unsigned int nBlocks = width * height;
  char info[nBlocks];
  if (! filelvl) { cerr << "[E] Fatal error: unable to open file to readlvl()!\n"; return false; }
  /* Controllo se sto leggendo un livello oltre la fine del file*/
  filelvl.seekg(0, ios::end); if (b > filelvl.tellg()) { cerr << "[W] This level does not exhist!\n"; return false; }

  filelvl.seekg(b, ios::beg);
  filelvl.read(info, nBlocks);
  if (! filelvl.failbit) { cerr << "[E] Fatal error: unable to parse file to readlvl()!\n"; return false; }
  if (info[0] == 'F') { cerr << "[W] Level file says it is finished\n"; return false; }
  /* Imposta il titolo come nome del livello */
  for (unsigned int c = 0; c < width; c++)
    { title[c] = info[c]; }
  cout << title << endl;
  short x, y;
  for (unsigned int c = width; c < nBlocks; c++)
  {
    if (info[c] == 0x01)
    {
      cout << "[I] Generating random block\n";
      info[c] = blockRandomTypes[(int)(((double)(rand()) / (double)(RAND_MAX)) * (N_RAND_BLOCKS - 1))];
    }
    x = c % width; y = c / width;
    block[x][y].init(info[c]);
  }
  return true;
}

static bool livello()
{
  /* NB: La funzione deve ritornare true se il livello è stato caricato correttamente!!
   * EDIT: Non è indispensabile che il livello venga letto da file, lo si può generare
   * automaticamente [questa possibilità è stata ridotta con degli aggiornamenti]
   */
  for (short y = 0; y < height; y++) for (short x = 0; x < width; x++) block[x][y].tipo = 0;
  lvl++;
  if (readlvl(384 * (lvl - 1) + 16)) { return true; }
    else
    {
      clog << "[W] Unable to load the level! Loading default level\n";
      msg("Impossibile leggere questo livello: caricamento Automatico.", 2000);
      SDL_WM_SetCaption("P Pong - Livello automatico", 0);
      strcpy(title, "Automatico");
      for (short x = 1; x < width - 1; x++)
        block[x][2].tipo = 10;
      return true;
    }
  return false;
}

