#define PADDING 5 /* distanza del testo dalle immagini nel menù*/
#define N_MENU_ENTRIES 5

static char menuEntry(void)
{
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  mouse(true);

  font(0, 20, "P Pong!", 0xFF0000);

  char entry[N_MENU_ENTRIES][25];
  strcpy(entry[0], "Nuova partita");
  strcpy(entry[1], "Carica partita salvata");
  strcpy(entry[2], "Opzioni");
  strcpy(entry[3], "Informazioni");
  strcpy(entry[4], "Esci");

  char desc[N_ICONE][25];
  strcpy(desc[1], "Accelera la pallina");
  strcpy(desc[2], "Decelera la pallina");
  strcpy(desc[3], "Sfonda i mattoni");
  strcpy(desc[4], "20 punti bonus");
  strcpy(desc[5], "30 punti bonus");
  strcpy(desc[6], "50 punti malus");
  strcpy(desc[7], "Allarga la racchetta");
  strcpy(desc[8], "Restringi la racchetta");
  strcpy(desc[9], "Bonus +1 vita");
  strcpy(desc[10], "Sparatutto!");
  strcpy(desc[11], "Clona la pallina");
  strcpy(desc[12], "+200 punti");
  strcpy(desc[13], "Pioggia di bonus");

  SDL_Rect spostamento;
  short i = 0, selezionato;

  char salvanome[256]; /*Se esiste una partita salvata, propone di continuarla*/
  strcpy(salvanome, ROOTDIR);
  strcat(salvanome, "partita.ppongsave");
  fstream file(salvanome, ios::in | ios::binary);
  if (file.is_open())
  {
    file.seekg(0, ios::beg);
    char t[4];
    file.read(t, 4);
    selezionato = cvl32(t) ? 1 : 0;
    //~ if (cvl32(t) != 0) selezionato = 1; else selezionato = 0;
    file.close();
  }
  else selezionato = 0;

  while (true)
  {
    /* Mostra l'immagine */
    i++;
    if (i >= N_ICONE) i = 1;
    lasttime.iconfade = SDL_GetTicks();
    short w = (icona[i]->w + strlen(desc[i]) * FONTW) + PADDING;
    spostamento.x = 319 - (w / 2);
    spostamento.y = 220;
    SDL_BlitSurface(icona[i], NULL, schermo, &spostamento);
    font(spostamento.x + icona[i]->w + PADDING, spostamento.y + (icona[i]->h / 2) - (FONTH / 2), desc[i], 0xFFFFFF);
    SDL_Flip(schermo);

    /* input */
    while (true)
    {
      SDL_PumpEvents();
           if (premuto(SDLK_DOWN)) { selezionato++; suona(MENU_SOUND); }
      else if (premuto(SDLK_UP)) { selezionato--; suona(MENU_SOUND); }
      else if (premuto(SDLK_c)) return 'c';
      else if (premuto(SDLK_ESCAPE)) return 'q';
      else if (premuto(SDLK_o)) return 'o';
      else if (premuto(SDLK_i)) return 'i';

      if (selezionato < 0) { selezionato = 0; suona(MENU_ERROR_SOUND); }
        else if (selezionato > (N_MENU_ENTRIES - 1)) { selezionato = N_MENU_ENTRIES - 1; suona(MENU_ERROR_SOUND); }

      if (premuto(SDLK_RETURN) || premuto(SDLK_RIGHT))
      {
        switch (selezionato)
        {
          case 0: return 'g'; break;
          case 1: return 'c'; break;
          case 2: return 'o'; break;
          case 3: return 'i'; break;
          case 4: return 'q'; break;
          default:
            clog << "[W] Something wrong in 'switch(selezionato)' in menuEntry()\n";
            msg("Not valid entry! See stderr");
            break;
        }
      }

      for (short n = 0; n < N_MENU_ENTRIES; n++)
      {
        font(0, 40 + n * FONTH, entry[n], selezionato == n ? 0xFFFF00 : 0x00FF00);
      }

      SDL_Flip(schermo);
      SDL_Delay(40);
      if (SDL_GetTicks() - lasttime.iconfade >= 1200) break;
    }
    boxColor(schermo, spostamento.x, spostamento.y, spostamento.x + w, spostamento.y + 100, 0x000000FF);
  }
}
